nix-tools/bin/mkchrootpkg.in

396 lines
11 KiB
Text
Raw Normal View History

2014-10-04 00:46:40 +02:00
#!/bin/bash
2014-11-18 19:20:53 +01:00
#
2014-10-04 00:46:40 +02:00
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
2014-10-08 13:14:28 +02:00
version=@version@
2014-11-13 16:31:15 +01:00
[[ -r @libdir@/util-msg.sh ]] && source @libdir@/util-msg.sh
[[ -r @libdir@/util.sh ]] && source @libdir@/util.sh
2014-11-12 04:15:40 +01:00
2014-10-04 00:46:40 +02:00
shopt -s nullglob
2014-11-12 02:19:58 +01:00
makepkg_args=(-s --noconfirm -L --holdver)
2014-10-04 00:46:40 +02:00
repack=false
update_first=false
clean_first=false
install_pkg=
run_namcap=false
temp_chroot=false
chrootdir=
passeddir=
declare -a install_pkgs
declare -i ret=0
copy=$USER
[[ -n $SUDO_USER ]] && copy=$SUDO_USER
[[ -z "$copy" || $copy = root ]] && copy=copy
src_owner=${SUDO_USER:-$USER}
usage() {
2014-11-13 20:19:57 +01:00
echo "Usage: ${0##*/} [options] -r <chrootdir> [--] [makepkg args]"
echo ' Run this script in a PKGBUILD dir to build a package inside a'
echo ' clean chroot. Arguments passed to this script after the'
echo ' end-of-options marker (--) will be passed to makepkg.'
echo ''
echo ' The chroot dir consists of the following directories:'
echo ' <chrootdir>/{root, copy} but only "root" is required'
echo ' by default. The working copy will be created as needed'
echo ''
echo ' The chroot "root" directory must be created via the following'
echo ' command:'
echo ' mkchroot <chrootdir>/root base-devel'
echo ''
echo " Default makepkg args: ${makepkg_args[*]}"
echo ''
echo ' Flags:'
echo ' -h This help'
echo ' -c Clean the chroot before building'
echo ' -u Update the working copy of the chroot before building'
echo ' This is useful for rebuilds without dirtying the pristine'
echo ' chroot'
echo ' -r <dir> The chroot dir to use'
echo ' -I <pkg> Install a package into the working copy of the chroot'
echo ' -l <copy> The directory to use as the working copy of the chroot'
echo ' Useful for maintaining multiple copies'
echo " Default: $copy"
echo ' -n Run namcap on the package'
echo ' -T Build in a temporary directory'
exit 1
2014-10-04 00:46:40 +02:00
}
2014-11-12 02:19:58 +01:00
orig_argv=("$@")
while getopts 'hcur:I:l:nT' arg; do
2014-11-13 20:19:57 +01:00
case "$arg" in
c) clean_first=true ;;
u) update_first=true ;;
r) passeddir="$OPTARG" ;;
I) install_pkgs+=("$OPTARG") ;;
l) copy="$OPTARG" ;;
n) run_namcap=true; makepkg_args+=(-i) ;;
T) temp_chroot=true; copy+="-$$" ;;
h|*) usage ;;
esac
2014-10-04 00:46:40 +02:00
done
2014-11-12 02:19:58 +01:00
[[ ! -f PKGBUILD && -z "${install_pkgs[*]}" ]] && die 'This must be run in a directory containing a PKGBUILD.'
check_root "$0" "${orig_argv[@]}"
2014-10-04 00:46:40 +02:00
# Canonicalize chrootdir, getting rid of trailing /
chrootdir=$(readlink -e "$passeddir")
2014-11-12 02:19:58 +01:00
[[ ! -d $chrootdir ]] && die "No chroot dir defined, or invalid path '%s'" "$passeddir"
[[ ! -d $chrootdir/root ]] && die "Missing chroot dir root directory. Try using: mkchroot %s/root base-devel" "$chrootdir"
# Detect chrootdir filesystem type
chroottype=$(stat -f -c %T "$chrootdir")
2014-10-04 00:46:40 +02:00
if [[ ${copy:0:1} = / ]]; then
copydir=$copy
else
copydir="$chrootdir/$copy"
fi
# Pass all arguments after -- right to makepkg
2014-11-12 02:19:58 +01:00
makepkg_args+=("${@:$OPTIND}")
2014-10-04 00:46:40 +02:00
# See if -R was passed to makepkg
2014-11-12 02:19:58 +01:00
for arg in "${@:OPTIND}"; do
2014-11-13 20:19:57 +01:00
case ${arg%%=*} in
-*R*|--repackage)
repack=true
break 2
;;
esac
2014-10-04 00:46:40 +02:00
done
2015-01-13 13:41:28 +01:00
load_user_info
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
# {{{ functions
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
create_chroot() {
# Lock the chroot we want to use. We'll keep this lock until we exit.
lock 9 "$copydir.lock" "Locking chroot copy [$copy]"
if [[ ! -d $copydir ]] || $clean_first; then
# Get a read lock on the root chroot to make
# sure we don't clone a half-updated chroot
slock 8 "$chrootdir/root.lock" "Locking clean chroot"
stat_busy "Creating clean working copy [$copy]"
if [[ "$chroottype" == btrfs ]] && ! mountpoint -q "$copydir"; then
if [[ -d $copydir ]]; then
btrfs subvolume delete "$copydir" >/dev/null ||
die "Unable to delete subvolume %s" "$copydir"
fi
btrfs subvolume snapshot "$chrootdir/root" "$copydir" >/dev/null ||
die "Unable to create subvolume %s" "$copydir"
else
mkdir -p "$copydir"
rsync -a --delete -q -W -x "$chrootdir/root/" "$copydir"
fi
2014-10-04 00:46:40 +02:00
stat_done
2014-11-12 02:19:58 +01:00
# Drop the read lock again
exec 8>&-
2014-10-04 00:46:40 +02:00
fi
2014-11-12 02:19:58 +01:00
# Update mtime
touch "$copydir"
}
clean_temporary() {
stat_busy "Removing temporary copy [$copy]"
if [[ "$chroottype" == btrfs ]] && ! mountpoint -q "$copydir"; then
btrfs subvolume delete "$copydir" >/dev/null ||
die "Unable to delete subvolume %s" "$copydir"
2014-10-04 00:46:40 +02:00
else
2014-11-12 02:19:58 +01:00
# avoid change of filesystem in case of an umount failure
rm --recursive --force --one-file-system "$copydir" ||
die "Unable to delete %s" "$copydir"
2014-10-04 00:46:40 +02:00
fi
2014-11-12 02:19:58 +01:00
# remove lock file
rm -f "$copydir.lock"
2014-10-04 00:46:40 +02:00
stat_done
2014-11-12 02:19:58 +01:00
}
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
install_packages() {
local pkgname
2014-10-04 00:46:40 +02:00
for install_pkg in "${install_pkgs[@]}"; do
pkgname="${install_pkg##*/}"
cp "$install_pkg" "$copydir/$pkgname"
2014-11-12 04:15:40 +01:00
chroot-run "$copydir" \
2014-11-12 02:19:58 +01:00
pacman -U /$pkgname --noconfirm
2014-10-04 00:46:40 +02:00
(( ret += !! $? ))
rm "$copydir/$pkgname"
done
2014-11-12 02:19:58 +01:00
# If there is no PKGBUILD we are done
2014-10-04 00:46:40 +02:00
[[ -f PKGBUILD ]] || exit $ret
2014-11-12 02:19:58 +01:00
}
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
prepare_chroot() {
$repack || rm -rf "$copydir/build"
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
mkdir -p "$copydir/build"
if ! grep -q 'BUILDDIR="/build"' "$copydir/etc/makepkg.conf"; then
echo 'BUILDDIR="/build"' >> "$copydir/etc/makepkg.conf"
fi
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
# Read .makepkg.conf and .gnupg/pubring.gpg even if called via sudo
2015-02-28 23:20:12 +01:00
if [[ -r $USER_HOME/.gnupg/pubring.kbx ]]; then
install -D "$USER_HOME/.gnupg/pubring.kbx" "$copydir/build/.gnupg/pubring.kbx"
fi
if [[ -r $USER_HOME/.gnupg/pubring.gpg ]]; then
2015-02-28 23:20:12 +01:00
install -D "$USER_HOME/.gnupg/pubring.gpg" "$copydir/build/.gnupg/pubring.gpg"
2014-11-12 02:19:58 +01:00
fi
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
mkdir -p "$copydir/pkgdest"
if ! grep -q 'PKGDEST="/pkgdest"' "$copydir/etc/makepkg.conf"; then
echo 'PKGDEST="/pkgdest"' >> "$copydir/etc/makepkg.conf"
2014-10-04 00:46:40 +02:00
fi
2014-11-12 02:19:58 +01:00
mkdir -p "$copydir/srcpkgdest"
if ! grep -q 'SRCPKGDEST="/srcpkgdest"' "$copydir/etc/makepkg.conf"; then
echo 'SRCPKGDEST="/srcpkgdest"' >> "$copydir/etc/makepkg.conf"
2014-10-04 00:46:40 +02:00
fi
2014-11-12 02:19:58 +01:00
mkdir -p "$copydir/logdest"
if ! grep -q 'LOGDEST="/logdest"' "$copydir/etc/makepkg.conf"; then
echo 'LOGDEST="/logdest"' >> "$copydir/etc/makepkg.conf"
fi
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
# These two get bind-mounted read-only
# XXX: makepkg dislikes having these dirs read-only, so separate them
mkdir -p "$copydir/startdir" "$copydir/startdir_host"
mkdir -p "$copydir/srcdest" "$copydir/srcdest_host"
if ! grep -q 'SRCDEST="/srcdest"' "$copydir/etc/makepkg.conf"; then
echo 'SRCDEST="/srcdest"' >> "$copydir/etc/makepkg.conf"
fi
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
builduser_uid=${SUDO_UID:-$UID}
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
# We can't use useradd without chrooting, otherwise it invokes PAM modules
# which we might not be able to load (i.e. when building i686 packages on
# an x86_64 host).
printf 'builduser:x:%d:100:builduser:/:/usr/bin/nologin\n' "$builduser_uid" >>"$copydir/etc/passwd"
chown -R "$builduser_uid" "$copydir"/{build,pkgdest,srcpkgdest,logdest,srcdest,startdir}
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
if [[ -n $MAKEFLAGS ]]; then
sed -i '/^MAKEFLAGS=/d' "$copydir/etc/makepkg.conf"
echo "MAKEFLAGS='${MAKEFLAGS}'" >> "$copydir/etc/makepkg.conf"
fi
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
if [[ -n $PACKAGER ]]; then
sed -i '/^PACKAGER=/d' "$copydir/etc/makepkg.conf"
echo "PACKAGER='${PACKAGER}'" >> "$copydir/etc/makepkg.conf"
fi
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
if [[ ! -f $copydir/etc/sudoers.d/builduser-pacman ]]; then
cat > "$copydir/etc/sudoers.d/builduser-pacman" <<EOF
Defaults env_keep += "HOME"
builduser ALL = NOPASSWD: /usr/bin/pacman
EOF
chmod 440 "$copydir/etc/sudoers.d/builduser-pacman"
fi
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
# This is a little gross, but this way the script is recreated every time in the
# working copy
{
printf '#!/bin/bash\n'
declare -f _chrootbuild
printf '_chrootbuild'
printf ' %q' "${makepkg_args[@]}"
printf ' || exit\n'
if $run_namcap; then
cat <<'EOF'
pacman -S --needed --noconfirm namcap
for pkgfile in /startdir/PKGBUILD /pkgdest/*; do
echo "Checking ${pkgfile##*/}"
sudo -u builduser namcap "$pkgfile" 2>&1 | tee "/logdest/${pkgfile##*/}-namcap.log"
done
EOF
2014-10-04 00:46:40 +02:00
fi
2014-11-12 02:19:58 +01:00
} >"$copydir/chrootbuild"
chmod +x "$copydir/chrootbuild"
}
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
download_sources() {
local builddir="$(mktemp -d)"
chmod 1777 "$builddir"
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
# Ensure sources are downloaded
if [[ -n $SUDO_USER ]]; then
sudo -u $SUDO_USER env SRCDEST="$SRCDEST" BUILDDIR="$builddir" \
makepkg --config="$copydir/etc/makepkg.conf" --verifysource -o
else
( export SRCDEST BUILDDIR="$builddir"
makepkg --asroot --config="$copydir/etc/makepkg.conf" --verifysource -o
)
fi
(( $? != 0 )) && die "Could not download sources."
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
# Clean up garbage from verifysource
rm -rf $builddir
}
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
_chrootbuild() {
# This function isn't run in makechrootpkg,
# so no global variables
. /etc/profile
export HOME=/build
shopt -s nullglob
# XXX: Workaround makepkg disliking read-only dirs
ln -sft /srcdest /srcdest_host/*
ln -sft /startdir /startdir_host/*
# XXX: Keep bzr and svn sources writable
# Since makepkg 4.1.1 they get checked out via cp -a, copying the symlink
for dir in /srcdest /startdir; do
for vcs in bzr svn; do
cd "$dir"
for vcsdir in */.$vcs; do
rm "${vcsdir%/.$vcs}"
cp -a "${dir}_host/${vcsdir%/.$vcs}" .
chown -R builduser "${vcsdir%/.$vcs}"
done
done
done
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
cd /startdir
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
# XXX: Keep PKGBUILD writable for pkgver()
rm PKGBUILD*
cp /startdir_host/PKGBUILD* .
chown builduser PKGBUILD*
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
# Safety check
if [[ ! -w PKGBUILD ]]; then
echo "Can't write to PKGBUILD!"
exit 1
fi
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
sudo -u builduser makepkg "$@"
}
move_products() {
for pkgfile in "$copydir"/pkgdest/*; do
2014-10-04 00:46:40 +02:00
chown "$src_owner" "$pkgfile"
mv "$pkgfile" "$PKGDEST"
done
2014-11-12 02:19:58 +01:00
for l in "$copydir"/logdest/*; do
[[ $l == */logpipe.* ]] && continue
2014-10-04 00:46:40 +02:00
chown "$src_owner" "$l"
2014-11-12 02:19:58 +01:00
mv "$l" "$LOGDEST"
done
for s in "$copydir"/srcpkgdest/*; do
chown "$src_owner" "$s"
mv "$s" "$SRCPKGDEST"
2014-10-04 00:46:40 +02:00
done
2014-11-12 02:19:58 +01:00
}
# }}}
umask 0022
load_vars "$USER_HOME/.makepkg.conf"
load_vars /etc/makepkg.conf
# Use PKGBUILD directory if these don't exist
[[ -d $PKGDEST ]] || PKGDEST=$PWD
[[ -d $SRCDEST ]] || SRCDEST=$PWD
[[ -d $SRCPKGDEST ]] || SRCPKGDEST=$PWD
[[ -d $LOGDEST ]] || LOGDEST=$PWD
create_chroot
2014-11-17 05:44:56 +01:00
$update_first && chroot-run \
-r "${mountargs_ro}" \
-w "${mountargs_rw}" \
"$copydir" \
pacman -Syu --noconfirm
2014-11-12 02:19:58 +01:00
[[ -n ${install_pkgs[*]} ]] && install_packages
prepare_chroot
download_sources
2014-11-17 05:44:56 +01:00
mountargs_ro="${PWD}:/startdir_host,${SRCDEST}:/srcdest_host"
if chroot-run -r "${mountargs_ro}" \
-w "${mountargs_rw}" \
2014-11-12 02:19:58 +01:00
"$copydir" \
/chrootbuild; then
move_products
2014-10-04 00:46:40 +02:00
else
2014-11-12 02:19:58 +01:00
(( ret += 1 ))
2014-10-04 00:46:40 +02:00
fi
2014-11-12 02:19:58 +01:00
$temp_chroot && clean_temporary
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
if (( ret != 0 )); then
if $temp_chroot; then
die "Build failed"
2014-10-04 00:46:40 +02:00
else
2014-11-12 02:19:58 +01:00
die "Build failed, check %s/build" "$copydir"
2014-10-04 00:46:40 +02:00
fi
else
true
fi